#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define int long long

using namespace std;

vector <vector <int>> a;

int dfs(int v, int p, int g) {
    int mx = g;
    for (auto i : a[v]) {
        if (p != i) {
            mx = max(dfs(i, v, g + 1), mx);
        }
    }
    return mx;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k, t;
    cin >> n >> k >> t;
    a.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        a[x - 1].push_back(y - 1);
        a[y - 1].push_back(x - 1);
    }
    int mn = 1e18;
    for (int i = 1; i < n; i++) {
        a[0].push_back(i);
        a[i].push_back(0);
        mn = min(mn, dfs(0, -1, 0));
        a[0].pop_back();
        a[i].pop_back();
    }
    cout << mn;
}
