#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define int long long

using namespace std;

int m;
vector <int> cl;
int ns = 0;

void dfs(int v) {
    for (int i = 0; i <= cl[i]; i += 3) {
        cl[i] -= 3;
        if (v != m) {
            dfs(v + 1);
        } else {
            vector <int> cl1 = cl;
            bool fl = true;
            for (int j = 1; j <= m; j++) {
                if (j < m - 1 && cl1[j] > 0 && cl1[j + 1] > 0 && cl1[j + 2] > 0) {
                    int rs = min(cl1[j], min(cl1[j + 1], cl1[j + 2]));
                    cl1[j] -= rs;
                    cl1[j + 1] -= rs;
                    cl1[j + 2] -= rs;
                }
                if (cl1[j] != 0) {
                    fl = false;
                    break;
                }
            }
            if (fl) {
                ns++;
                ns %= (int)(1e9 + 7);
            }
        }
        cl[i] += 3;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n >> m;
    cl.resize(m + 5);
    int mx = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        cl[x]++;
        mx = max(mx, cl[x]);
    }
    if (m <= 3) {
        int ans = 0;
        for (int i = 0; i <= cl[1]; i += 3) {
            for (int j = 0; j <= cl[2]; j += 3) {
                for (int h = 0; h <= cl[3]; h += 3) {
                    if (cl[1] - i == cl[2] - j && cl[1] - i == cl[3] - h) {
                        ans++;
                    }
                }
            }
        }
        cout << ans;
    } else if (m == 4) {
        int ans = 0;
        for (int i = 0; i <= cl[1]; i += 3) {
            for (int j = 0; j <= cl[2]; j += 3) {
                cl[1] -= i;
                cl[2] -= j;
                if (cl[1] <= cl[2] && cl[3] >= cl[2] && (cl[3] - cl[2]) % 3 == 0 && cl[4] >= cl[2] - cl[1] && (cl[4] - (cl[2] - cl[1])) % 3 == 0) {
                    ans++;
                }
                cl[1] += i;
                cl[2] += j;
            }
        }
        cout << ans;
    } else if (mx < 3) {
        bool fl = true;
        for (int i = 1; i <= m; i++) {
            if (i < m - 1 && cl[i] > 0 && cl[i + 1] > 0 && cl[i + 2] > 0) {
                int rs = min(cl[i], min(cl[i + 1], cl[i + 2]));
                cl[i] -= rs;
                cl[i + 1] -= rs;
                cl[i + 2] -= rs;
            }
            if (cl[i] != 0) {
                fl = false;
            }
        }
        if (!fl) {
            cout << 0;
        } else {
            cout << 1;
        }
    } else {
        dfs(1);
        cout << ns;
    }
}