#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define int long long

using namespace std;

int m;
vector <int> cl;
vector <int> op1, op2;
map <pair <vector <int>, vector <int>>, bool> mp;
map <vector <int>, int> dp;

int dfs(vector <int> &col) {
    int ans = 0;
    bool fl = false;
    for (int i = 1; i <= m; i++) {
        if (col[i] > 0) {
            fl = true;
        }
        if (col[i] >= 3) {
            col[i] -= 3;
            op1[i]++;
            if (!mp[{op1, op2}]) {
                if (dp.find(col) == dp.end()) {
                    dp[col] = dfs(col) % (int)(1e9 + 7);
                }
                ans += dp[col];
                ans %= (int)1e9 + 7;
                mp[{op1, op2}] = true;
            }
            op1[i]--;
            col[i] += 3;
        }
        if (i < m - 1 && col[i] > 0 && col[i + 1] > 0 && col[i + 2] > 0) {
            col[i]--;
            col[i + 1]--;
            col[i + 2]--;
            op2[i]++;
            if (!mp[{op1, op2}]) {
                if (dp.find(col) == dp.end()) {
                    dp[col] = dfs(col) % (int)(1e9 + 7);
                }
                ans += dp[col];
                ans %= (int)1e9 + 7;
                mp[{op1, op2}] = true;
            }
            op2[i]--;
            col[i]++;
            col[i + 1]++;
            col[i + 2]++;
        }
    }
    if (!fl) {
        return 1;
    } else {
        return ans;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n >> m;
    cl.resize(m + 1);
    op1.resize(m + 1);
    op2.resize(m + 1);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        cl[x]++;
    }
    cout << dfs(cl);
}