#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define int long long

using namespace std;

vector <vector <int>> a;
vector <int> gl;
vector <bool> used;
int m;

void d(int v, int p, int g) {
    gl[v] = g;
    for (auto i : a[v]) {
        if (i != p) {
            d(i, v, g + 1);
        }
    }
}

void dfs(int v, int g) {
    used[v] = true;
    m = max(m, g);
    for (int i = a[v].size() - 1; i > -1; i--) {
        if (!used[a[v][i]] && gl[v] < gl[a[v][i]]) {
            dfs(a[v][i], g + 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k, t;
    cin >> n >> k >> t;
    a.resize(n);
    gl.resize(n);
    used.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        a[x - 1].push_back(y - 1);
        a[y - 1].push_back(x - 1);
    }
    d(0, -1, 0);
    if (k == 1 && n <= 2000) {
        int ans = 1e18;
        for (int j = 1; j < n; j++) {
            m = 0;
            fill(used.begin(), used.end(), 0);
            a[0].push_back(j);
            dfs(0, 0);
            ans = min(ans, m);
            a[0].pop_back();
        }
        cout << ans;
    } else {
        multiset <int> st;
        st.insert(n - 1);
        while (k != 0) {
            int rs = *(--st.end());
            if (rs == 1) {
                break;
            }
            st.erase(--st.end());
            if (rs % 2 == 0) {
                st.insert(rs / 2);
                st.insert(rs / 2);
            } else {
                st.insert(rs / 2);
                st.insert(rs / 2 + 1);
            }
            k--;
        }
        cout << *(--st.end());
    }
}